//
//  ViewController.swift
//  抖音双击点赞动画
//
//  Created by 张崇超 on 2018/6/28.
//  Copyright © 2018年 ZCC. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let singleTap = UITapGestureRecognizer.init(target: self, action: #selector(singleAction))
        singleTap.numberOfTapsRequired = 1
        self.view.addGestureRecognizer(singleTap)
        
        let doubleTap = UITapGestureRecognizer.init(target: self, action: #selector(doubleAction))
        doubleTap.numberOfTapsRequired = 2
        self.view.addGestureRecognizer(doubleTap)
        
        singleTap.require(toFail: doubleTap)
    }
    
    @objc func singleAction(pan: UITapGestureRecognizer) {
        
        if ZanAnimation.isContinue {
            
            ZanAnimation.showAnimation(point: pan.location(in: self.view), baseView: self.view)
            
        } else {
            
            print("我是单击:\(Date.init())")
        }
    }
    @objc func doubleAction(pan: UITapGestureRecognizer) {
        
        ZanAnimation.showAnimation(point: pan.location(in: self.view), baseView: self.view)
    }
    
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }


}

