//
//  ZanAnimation.swift
//  SuperVolley
//
//  Created by 张崇超 on 2018/5/7.
//  Copyright © 2018年 Zebra. All rights reserved.
//

import UIKit

class ZanAnimation: NSObject {
    
    /// 是否继续动画, 单击手势与双击冲突时使用
    static var isContinue: Bool {
        
        return !ZanAnimation.allImgVArr.isEmpty
    }
    static private let size: CGFloat = 80.0
    static private let angleArr: [CGFloat] = [CGFloat.pi / 4.0, -CGFloat.pi / 4.0, 0.0]
    static private var allImgVArr: [UIImageView] = []
    
    static func showAnimation(point: CGPoint, baseView: UIView) {
        
        let imgV = UIImageView.init(frame: CGRect.init(x: point.x - ZanAnimation.size / 2.0, y: point.y - ZanAnimation.size / 2.0, width: size, height: size))
        imgV.image = #imageLiteral(resourceName: "zanHeart")
        imgV.contentMode = .scaleAspectFill
        baseView.addSubview(imgV)
        ZanAnimation.allImgVArr.append(imgV)
        
        // 偏移角度
        let num = Int(arc4random_uniform(3))
        imgV.transform = CGAffineTransform.init(rotationAngle: ZanAnimation.angleArr[num])
        // 放大动画
        let animation = CAKeyframeAnimation(keyPath: "transform.scale")
        animation.duration = 0.15;
        animation.calculationMode = kCAAnimationCubic;
        animation.values = [1.3, 0.8, 1.0]
        imgV.layer.add(animation, forKey: "transform.scale")
        
        DispatchQueue.main.asyncAfter(deadline: DispatchTime.now() + 0.5) {
            
            UIView.animate(withDuration: 0.5, animations: {
                
                imgV.alpha = 0.0
                var newFrame = imgV.frame
                newFrame.origin.x -= 5.0
                newFrame.origin.y -= 45.0
                newFrame.size.height += 10.0
                newFrame.size.width += 10.0
                imgV.frame = newFrame
                
            }, completion: { (isOK) in
                
                imgV.removeFromSuperview()
                if let index = ZanAnimation.allImgVArr.index(of: imgV) {
                    
                    ZanAnimation.allImgVArr.remove(at: index)
                }
            })
        }
    }
}
